OBJ
  tv    : "sw_dk_tv_drv_022.spin"
  fant  : "sw_fantasia_drv_001.spin"
'  hdmf_lite : "EPM_HDMF_Lite_custom_DK_driver_010.spin"      ' HDMF Lite driver

CON
    _clkmode = xtal1 + pll8x
    _xinfreq = 10_000_000 + 0000
    _stack = 60
    COGS = 6

VAR
    word    xd[2]
    word    yd[2]
    long    rnd
    word    tv_status_ptr
    byte    colors[70]
    
PUB Main | i,chroma,luma

    fant.start(COGS,@tv_status_ptr)

    i:=0
    repeat luma from 2 to 7
        colors[i++]:=luma
    repeat luma from 11 to 14
        repeat chroma from 0 to 15
            colors[i++]:=chroma*16+luma

    rnd:=$24559f37
    Wait(60)
    repeat
        fant.NewString(0,$180,$200,string("Welcome to..."),10,3)
        Wait(180)
        fant.NewString(1,$380,$600,string("F"),0,3)
        fant.NewString(2,$480,$600,string("a"),2,3)
        fant.NewString(3,$580,$600,string("n"),4,3)
        fant.NewString(4,$680,$600,string("t"),6,3)
        fant.NewString(5,$780,$600,string("a"),8,3)
        fant.NewString(6,$880,$600,string("s"),10,3)
        fant.NewString(7,$980,$600,string("i"),12,3)
        fant.NewString(8,$a80,$600,string("a"),14,3)
        fant.NewString(9,$b80,$600,string("!"),0,3)
        Wait(10)
        fant.DeltaStringColor(0,0,-1)
        Wait(30)
        fant.DeltaStringColor(0,0,-1)
        Wait(30)
        fant.DeltaStringColor(0,0,-1)
        Wait(30)
        fant.DeleteString(0)
        Wait(180)
        fant.NewString(1,$0,$0,   string("F"),0,2)
        fant.NewString(2,$100,$0, string("a"),2,2)
        fant.NewString(3,$200,$0, string("n"),4,2)
        fant.NewString(4,$300,$0, string("t"),6,2)
        fant.NewString(5,$400,$0, string("a"),8,2)
        fant.NewString(6,$500,$0, string("s"),10,2)
        fant.NewString(7,$600,$0, string("i"),12,2)
        fant.NewString(8,$700,$0, string("a"),14,2)
        fant.NewString(0,$900,$0, string("is a"),10,1)
        fant.NewString(9,$0,$200, string("TV driver for"),10,1)
        fant.NewString(10,$0,$400,string("displaying text."),10,1)
        Wait(300)
        fant.NewString(0,$900,$0, string(" "),10,1)
        fant.NewString(9,$0,$200, string("supports an 86"),10,1)
        fant.NewString(10,$0,$400,string("color display."),10,1)
        Wait(300)
        fant.NewString(0,$900,$0, string(" "),10,1)
        fant.NewString(9,$0,$200, string("displays text on"),10,1)
        fant.NewString(10,$0,$400,string("the fly so does"),10,1)
        fant.NewString(11,$0,$600,string("not need a frame"),10,1)
        fant.NewString(12,$0,$800,string("buffer."),10,1)
        Wait(300)
        fant.NewString(0,$900,$0, string("doesn't"),10,1)
        fant.NewString(9,$0,$200, string("use a tile map  "),10,1)
        fant.NewString(10,$0,$400,string("so text can be"),10,1)
        fant.NewString(11,$0,$600,string("displayed"),10,1)
        fant.NewString(12,$0,$800,string("anywhere on the"),10,1)
        fant.NewString(13,$0,$a00,string("screen."),10,1)
        Wait(180)
        repeat 5
            repeat i from $00 to $200 step 16
                Wait(1)
                fant.DeltaStringPos(12,$0,+4)    
                fant.DeltaStringPos(13,$0,+8)    
            repeat i from $00 to $200 step 16
                Wait(1)
                fant.DeltaStringPos(12,$0,-4)
                fant.DeltaStringPos(13,$0,-8)
        Wait(60)
        fant.NewString(0,$0,$0,   string("(Well almost.   "),10,1)
        fant.NewString(1,$0,$200, string("Horizontal"),10,1)
        fant.NewString(2,$0,$400,string("granularity is"),10,1)
        fant.NewString(3,$0,$600,string("4 pixels"),10,1)
        fant.NewString(4,$0,$800,string("for efficiency"),10,1)
        fant.NewString(5,$0,$a00,string("reasons.)"),10,1)
        fant.DeleteString(6)
        fant.DeleteString(7)
        fant.DeleteString(8)
        fant.DeleteString(9)
        fant.DeleteString(10)
        fant.DeleteString(11)
        fant.DeleteString(12)
        fant.DeleteString(13)
        Wait(180)
        repeat 3
            repeat i from $00 to $600 step 32
                Wait(1)
                fant.MoveStringTo(3,i,$600)    
            repeat i from $00 to $600 step 32
                Wait(1)
                fant.MoveStringTo(3,$600-i,$600)
        Wait(120)
        fant.NewString(0,$380,$600,string("F"),0,3)
        fant.NewString(1,$480,$600,string("a"),2,3)
        fant.NewString(2,$580,$600,string("n"),4,3)
        fant.NewString(3,$680,$600,string("t"),6,3)
        fant.NewString(4,$780,$600,string("a"),8,3)
        fant.NewString(5,$880,$600,string("s"),10,3)
        fant.NewString(6,$980,$600,string("i"),12,3)
        fant.NewString(7,$a80,$600,string("a"),14,3)
        fant.NewString(8,$b80,$600,string("!"),0,3)
        Wait(240)
        repeat 800
            Wait(1)      
            repeat i from 0 to 8
                fant.DeltaStringPos(i,lookupz(i:-15,+20,-5,+30,-25,9,-10,15,-20),lookupz(i:10,-15,20,-5,10,10,-15,20,-10))
    
PRI Wait(aTime) | target
    {{
    Waits for a time specified in thousanths of a second
    }}
    repeat aTime
        long[tv_status_ptr]:=0
        repeat until long[tv_status_ptr]>0
        
 